package com.persagy.proxy.adm.constant;

/**
 * BDTP中台图类型编码和边类型编码的组合名称
 * 
 * @version 1.0.0
 * @company persagy 
 * @author zhangqiankun
 * @date 2021年9月3日 上午9:55:09
 */
public interface AdmRelationType {

	/** 默认的处理类 */
	String DEFAULT_RELATION_OBJECT = "deafultRelationObject";
	
	/** MECHINARCH_EQ2BD  设备所在建筑*/
	String MECHINARCH_EQ2BD = "MechInArch_Eq2Bd";
	
	/** MECHINARCH_EQ2FL  设备所在楼层*/
	String MECHINARCH_EQ2FL = "MechInArch_Eq2Fl";
	
	/** MECHINARCH_EQ2SH  设备所在竖井*/
	String MECHINARCH_EQ2SH = "MechInArch_Eq2Sh";
	
	/** MECHINARCH_EQ2BD  设备所在空间*/
	String MECHINARCH_EQ2SP = "MechInArch_Eq2Sp";

	
	
	/** MECHFORARCH_EQ2BD  设备服务于建筑*/
	String MECHFORARCH_EQ2BD = "MechForArch_Eq2Bd";
	
	/** MECHFORARCH_EQ2FL  设备服务于楼层*/
	String MECHFORARCH_EQ2FL = "MechForArch_Eq2Fl";
	
	/** MECHFORARCH_EQ2SH  设备服务于竖井*/
	String MECHFORARCH_EQ2SH = "MechForArch_Eq2Sh";
	
	/** MECHFORARCH_SY2BD  系统服务于建筑*/
	String MECHFORARCH_SY2BD = "MechForArch_Sy2Bd";
	
	/** MECHFORARCH_SY2FL  系统服务于楼层*/
	String MECHFORARCH_SY2FL = "MechForArch_Sy2Fl";
	
	/** MECHFORARCH_SY2SH  系统服务于竖井*/
	String MECHFORARCH_SY2SH = "MechForArch_Sy2Sh";
	
	/** MECHFORARCH_SY2SP  系统服务于空间*/
	String MECHFORARCH_SY2SP = "MechForArch_Sy2Sp";
	
	
	
	/** ARCHSUBSET_BD2FL  建筑下的楼层*/
	String ARCHSUBSET_BD2FL = "ArchSubset_Bd2Fl";
	
	
	
	/** ARCHFORARCH_SH2BD  竖井服务于建筑*/
	String ARCHFORARCH_SH2BD = "ArchForArch_Sh2Bd";
	
	/** ARCHFORARCH_SH2FL  竖井服务于楼层*/
	String ARCHFORARCH_SH2FL = "ArchForArch_Sh2Fl";
	
	/** ARCHFORARCH_SH2SH  竖井服务于竖井*/
	String ARCHFORARCH_SH2SH = "ArchForArch_Sh2Sh";
	
	/** ARCHFORARCH_SH2SP  竖井服务于空间*/
	String ARCHFORARCH_SH2SP = "ArchForArch_Sh2Sp";
	
	/** ARCHFORARCH_SP2BD  空间服务于建筑*/
	String ARCHFORARCH_SP2BD = "ArchForArch_Sp2Bd";
	
	/** ARCHFORARCH_SP2FL  空间服务于楼层*/
	String ARCHFORARCH_SP2FL = "ArchForArch_Sp2Fl";
	
	
	
	/** EQUIPPOWER_EQBACKUP  设备备用电源-低/高压开关柜→用电设备*/
	String EQUIPPOWER_EQBACKUP = "EquipPower_EqBackup";
	
	/** EQUIPPOWER_EQNORMAL  设备常规电源-低/高压开关柜→用电设备*/
	String EQUIPPOWER_EQNORMAL = "EquipPower_EqNormal";
	
	/** EQUIPPOWER_SYBACKUP  系统备用电源-低/高压开关柜→用电设备*/
	String EQUIPPOWER_SYBACKUP = "EquipPower_SyBackup";
	
	/** EQUIPPOWER_SYNORMAL  系统常规电源-低/高压开关柜→用电设备*/
	String EQUIPPOWER_SYNORMAL = "EquipPower_SyNormal";
	
	
	
	/** RADIATIONNETWORK_TRANSPARENT  光照透明隔断-空间-空间*/
	String RADIATIONNETWORK_TRANSPARENT = "RadiationNetwork_Transparent";
	
	/** RADIATIONNETWORK_CONNECT  光照连通-空间-空间*/
	String RADIATIONNETWORK_CONNECT = "RadiationNetwork_Connect";
	
	
	
	/** TRAFFICNETWORK_FFCLOSE  消防常关交通-空间-空间*/
	String TRAFFICNETWORK_FFCLOSE = "TrafficNetwork_FFClose";
	
	/** TRAFFICNETWORK_FFOPEN  消防常开交通-业务空间-业务空间*/
	String TRAFFICNETWORK_FFOPEN = "TrafficNetwork_FFOpen";

	/** TRAFFICNETWORK_NORMAL  普通交通-空间-空间*/
	String TRAFFICNETWORK_NORMAL = "TrafficNetwork_Normal";
	
	
	
	/** CONVECTIONNETWORK_MIXMECH  空气混合机械通风-空间-空间*/
	String CONVECTIONNETWORK_MIXMECH = "ConvectionNetwork_MixMech";

	/** CONVECTIONNETWORK_NATURAL  空气自然对流-空间-空间*/
	String CONVECTIONNETWORK_NATURAL = "ConvectionNetwork_Natural";
	
	/** CONVECTIONNETWORK_ONEWAYMECH  空气单向机械通风-空间→空间*/
	String CONVECTIONNETWORK_ONEWAYMECH = "ConvectionNetwork_OnewayMech";
	
	
	
	/** SENSORRELATIONSHIP_SS2EQ  传感器测量设备关系-传感器→被测设备*/
	String SENSORRELATIONSHIP_SS2EQ = "SensorRelationship_Ss2Eq";
	
	/** SENSORRELATIONSHIP_SS2SP  传感器测量空间关系-传感器→被测空间*/
	String SENSORRELATIONSHIP_SS2SP = "SensorRelationship_Ss2Sp";
	
	/** SENSORRELATIONSHIP_SS2SY  传感器测量系统关系-传感器→被测系统*/
	String SENSORRELATIONSHIP_SS2SY = "SensorRelationship_Ss2Sy";
	
}
