package com.persagy.proxy.object.model;

import com.fasterxml.jackson.databind.node.ArrayNode;
import lombok.Data;

import java.util.Date;
import java.util.Map;

/**
 * ADM 元空间 实体
 * @author lvxy
 * @date 2021/8/17
 */
@Data
public class AdmISpace {

    public static final String OBJ_TYPE = "ispace";
    /** 空间ID */
    private String id;
    /** 名称 */
    private String name;
    /** 本地编码 */
    private String localId;
    /** 本地名称 */
    private String localName;

    /** 项目ID */
    private String projectId;
    /** 建筑ID */
    private String buildingId;
    /** 楼层ID */
    private String floorId;
    /** 二维码图片 */
    private String qrCode;
    /** BIM模型中编码 */
    private String bimId;
    /** BIM模型中坐标 */
    private String bimLocation;
    /** 模型文件id */
    private String modelId;
    /** 空间功能区类型 */
    private String funcType;

    /** 井深 */
    private Float depth;
    /** 面宽 */
    private Float width;
    /** 建筑面积 */
    private Float buildArea;
    /** 使用面积 */
    private Float netArea;
    /** 高 */
    private Float height;

    /** 图片 */
    private ArrayNode pic;
    /** 空间是否受影响 */
    private String state;
    /** 空间常驻人数 */
    private Integer permanentPeopleNum;

    /** 配电容量 */
    private Float elecCap;
    /** 污染等级 */
    private String pollutionDegree;

    /** 备注文字 */
    private String intro;
    /** 信息点 */
    private Map<String, Object> infos;
    /** 对象类型 */
    private String objectType = OBJ_TYPE;

    /** 轮廓线 */
    private ArrayNode outline;

    /** 对象类型code */
    private String classCode;
    /** 创建时间 */
    private Date createTime;

}
