package com.persagy.proxy.report.model;

import org.apache.poi.ss.usermodel.Font;

import com.alibaba.excel.annotation.ExcelProperty;
import com.alibaba.excel.annotation.write.style.ColumnWidth;
import com.alibaba.excel.annotation.write.style.HeadFontStyle;

import lombok.Getter;
import lombok.Setter;

/**
 * @version 
 * @description 不在空间内的设备数据导出实体类
 * @company persagy
 * @author zhangqiankun
 * @since 2020年11月26日:	下午12:30:39
 */
@Getter
@Setter
@HeadFontStyle(color = Font.COLOR_NORMAL)
public class EquipmentExcel {
	
	@ColumnWidth(50)
	@ExcelProperty(value = "设备id", index=0)
	private String id;
	
	@ColumnWidth(20)
	@ExcelProperty(value = "设备名称", index=1)
	private String name;

	@ColumnWidth(20)
	@ExcelProperty(value = "设备本地名称", index=2)
	private String localName;

	@ColumnWidth(20)
	@ExcelProperty(value = "设备本地编码", index=3)
	private String localId;
	
	@ColumnWidth(50)
	@ExcelProperty(value = "BIMID", index=4)
	private String bimId;

	@ColumnWidth(20)
	@ExcelProperty(value = "设备类", index=5)
	private String classCodeName;
	
	@ColumnWidth(25)
	@ExcelProperty(value = "建筑", index=6)
	private String buildName;
	
	@ColumnWidth(25)
	@ExcelProperty(value = "楼层", index=7)
	private String floorName; 
	
	@ColumnWidth(20)
	@ExcelProperty(value = "模型文件名", index=8)
	private String modelFileName;
	
}
